OBJ
  xvideo : "JAM_XVIDEO_001"
  'Include tileset generated with XVIDTOOL
  tiles : "tileset.spin"
  'Include sprite generated with XVIDTOOL
  yoshi : "yoshi.spin"
CON
        _CLKMODE                = xtal1 + pll8x
        _XINFREQ                = 10_000_000 + 0000

VAR
  LONG Yoshi1V[8*2]   'Table of Yoshi's velocities (only the first layer sprites, the ones
                      'that demonstrate edge clipping)
  LONG Yoshi1P[8*2]   'Table of layer 0 yoshi positions

  LONG Yoshi2X[8]     'Table of layer 1 yoshu positions
                      '(the yoshis moving across the screen horizontally)                        
PUB TestStuffs | i, x, y, vx, vy, x1,y1,vx1,vy1, c, z  
  'Start the XVIDEO driver cogs (after this, a black screen is displayed)
  xvideo.Launch

  'Load the tileset into SRAM, after this tiles may be used.
  xvideo.LoadTiles(0,tiles.GetTilesetPtr, 32)
  'Load the background tilemap into SRAM. Note that the driver is still STOPPED,
  'ie. it's still displaying a black screen after this.
  xvideo.LoadTilemap(0, @s_test_tilemap_0, 5, 16)
  'Load the foreground tilemap (the one over the sprites). 
  xvideo.LoadTilemap(1, @s_test_tilemap_1, 5, 16)


  'Initialize demo data, ie. Yoshi locations and velocities
  Yoshi1V[0*2+0] := 1 'Yoshi 0 X Velocity 
  Yoshi1V[0*2+1] := 0 'Yoshi 0 Y Velocity
  
  Yoshi1V[1*2+0] := 1 'Yoshi 1 X Velocity
  Yoshi1V[1*2+1] := 0 'Yoshi 1 Y Velocity

  Yoshi1V[2*2+0] := 0 'Yoshi 2 X Velocity
  Yoshi1V[2*2+1] := 1 'Yoshi 2 Y Velocity

  Yoshi1V[3*2+0] := 0 'Yoshi 3 X Velocity
  Yoshi1V[3*2+1] := 1 'Yoshi 3 Y Velocity

  Yoshi1V[4*2+0] := -1'Yoshi 4 X Velocity
  Yoshi1V[4*2+1] := 0 'Yoshi 4 Y Velocity

  Yoshi1V[5*2+0] := -1'Yoshi 5 X Velocity
  Yoshi1V[5*2+1] := 0 'Yoshi 5 Y Velocity

  Yoshi1V[6*2+0] := 0 'Yoshi 6 X Velocity
  Yoshi1V[6*2+1] := -1'Yoshi 6 Y Velocity

  Yoshi1V[7*2+0] := 0 'Yoshi 7 X Velocity
  Yoshi1V[7*2+1] := -1'Yoshi 7 Y Velocity

  Yoshi1P[0*2+0] := -16 'Yoshi 0 X Position
  Yoshi1P[0*2+1] := -16 'Yoshi 0 Y Position

  Yoshi1P[1*2+0] :=  88 'Yoshi 1 X Position
  Yoshi1P[1*2+1] := -16 'Yoshi 1 Y Position

  Yoshi1P[2*2+0] := 192 'Yoshi 2 X Position
  Yoshi1P[2*2+1] := -16 'Yoshi 2 Y Position

  Yoshi1P[3*2+0] := 192 'Yoshi 3 X Position
  Yoshi1P[3*2+1] := 80  'Yoshi 3 Y Position

  Yoshi1P[4*2+0] := 192 'Yoshi 4 X Position
  Yoshi1P[4*2+1] := 176 'Yoshi 4 Y Position

  Yoshi1P[5*2+0] :=  88 'Yoshi 5 X Position
  Yoshi1P[5*2+1] := 176 'Yoshi 5 Y Position

  Yoshi1P[6*2+0] := -16 'Yoshi 6 X Position
  Yoshi1P[6*2+1] := 176 'Yoshi 6 Y Position

  Yoshi1P[7*2+0] := -16 'Yoshi 7 X Position
  Yoshi1P[7*2+1] :=  80 'Yoshi 7 Y Position

  Yoshi2X[0] := -32    'Yoshi 8 X
  Yoshi2X[1] := 32     'Yoshi 9 X
  Yoshi2X[2] := 96    'Yoshi 10 X
  Yoshi2X[3] := 160    'Yoshi 11 X
  Yoshi2X[4] := -32    'Yoshi 12 X
  Yoshi2X[5] := 36     'Yoshi 13 X
  Yoshi2X[6] := 96    'Yoshi 14 X
  Yoshi2X[7] := 160    'Yoshi 15 X
  

   

  'Configure the sprites - set their sizes, pointers and initial positions.
  'Note that sprites aren't stored in SRAM.
  'Because the sprites are moved right after initializing, sprite locations
  'don't really matter here - but if too much stuff is on the same scanline,
  'even here, there'll be a visible glitch.
  xvideo.ConfigureSprite(0,5,32,yoshi.Get_marioyoshi, -12,-12) 
  xvideo.ConfigureSprite(1,5,32,yoshi.Get_marioyoshi, 208-24,-24) 
  xvideo.ConfigureSprite(2,5,32,yoshi.Get_marioyoshi, 208-24,192-24                                            )
  xvideo.ConfigureSprite(3,5,32,yoshi.Get_marioyoshi, -12,192-24) 

  xvideo.ConfigureSprite(4,5,32,yoshi.Get_marioyoshi, 0+1,32) 
  xvideo.ConfigureSprite(5,5,32,yoshi.Get_marioyoshi, 32+1,32) 
  xvideo.ConfigureSprite(6,5,32,yoshi.Get_marioyoshi, 64+1,32) 
  xvideo.ConfigureSprite(7,5,32,yoshi.Get_marioyoshi, 0, 32) 

  xvideo.ConfigureSprite( 8,5,32,yoshi.Get_marioyoshi, 0+1,50) 
  xvideo.ConfigureSprite( 9,5,32,yoshi.Get_marioyoshi, 40+1,50) 
  xvideo.ConfigureSprite(10,5,32,yoshi.Get_marioyoshi, 80+1,50) 
  xvideo.ConfigureSprite(11,5,32,yoshi.Get_marioyoshi, 120+1,50) 

  xvideo.ConfigureSprite(12,5,32,yoshi.Get_marioyoshi, 0+1,100) 
  xvideo.ConfigureSprite(13,5,32,yoshi.Get_marioyoshi, 40+1,100) 
  xvideo.ConfigureSprite(14,5,32,yoshi.Get_marioyoshi, 80+1,100) 
  xvideo.ConfigureSprite(15,5,32,yoshi.Get_marioyoshi, 120+1,100)



  xvideo.StartRasterizing
  x:=0  
  y:=0
  vx:=2 
  vy:=2
  i := %1000_1_101
  c:=0
  x1 := 10
  y1 := 00
  repeat
    'MOve the yoshis on layer 0, the ones circling around the edges
    repeat z from 0 to 7
      
      Yoshi1P[z*2+0] += Yoshi1V[z*2+0]  
      Yoshi1P[z*2+1] += Yoshi1V[z*2+1]
      xvideo.MoveSprite(z,Yoshi1P[z*2+0],Yoshi1P[z*2+1]) 
      case Yoshi1V[z*2+0] 'Change yoshi direction if edge is hit
        -1:
          if(Yoshi1P[z*2+0] == -16)
            Yoshi1V[z*2+0] := 0
            Yoshi1V[z*2+1] := -1                                
        1:
          if(Yoshi1P[z*2+0] == 192)
            Yoshi1V[z*2+0] := 0
            Yoshi1V[z*2+1] := 1                                
        0:
          case Yoshi1V[z*2+1]
           -1:
            if(Yoshi1P[z*2+1] == -16)
              Yoshi1V[z*2+0] := 1
              Yoshi1V[z*2+1] := 0           
           1:
            if(Yoshi1P[z*2+1] == 176)
              Yoshi1V[z*2+0] := -1
              Yoshi1V[z*2+1] := 0


    'Move the yoshis on layer 1, the ones moving horizontally
    repeat z from 0 to 3
      Yoshi2X[z]++
      if(Yoshi2X[z] > 208)
        Yoshi2X[z] := -32
      xvideo.MoveSprite(z+8, Yoshi2X[z], 50)
    repeat z from 4 to 7
      Yoshi2X[z]--
      if(Yoshi2X[z] < -32)
        Yoshi2X[z] := 208
      xvideo.MoveSprite(z+8, Yoshi2X[z], 100)
          
                  
    'Cycle background color                                              
    xvideo.SetBGColor(i)    
    c+=1
    i+=%10000
    i &= $FF
    waitcnt(cnt+80_000_000/16) 'Render a little bit FASTER than FPS (15) - otherwise it'll look ugly.

    if(x1 > 208+32)
      vx1 := -1

    if(y1 > 100)
      vy1 := -1

    if(y1 < 10)
      vy1 := 1
    if(x1 < 208-32)
      vx1 := 1

    x+=vx
    y+=vy
    if(x>47)
      vx:=-2
    if(x==0)
      vx := 2
    if( y>31)
      vy := -2
    if(y==0)
      vy := 2
    xvideo.ScrollTilemap(0, x, 0)
    xvideo.ScrollTilemap(1, 0, y)

DAT
s_test_tilemap_0
        byte $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        byte $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        byte $04,$04,$04,$04,$05,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$00,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        byte $08,$08,$08,$08,$08,$05,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$00,$00,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        byte $08,$09,$08,$08,$08,$08,$05,$FF,$FF,$FF,$FF,$FF,$00,$00,$00,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        byte $08,$14,$08,$08,$08,$08,$08,$05,$FF,$FF,$FF,$00,$00,$00,$00,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        byte $08,$08,$08,$08,$08,$08,$08,$08,$05,$FF,$00,$00,$00,$00,$00,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        byte $08,$08,$08,$08,$08,$08,$08,$08,$08,$00,$00,$00,$00,$00,$00,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        byte $08,$08,$08,$08,$08,$08,$08,$08,$00,$00,$00,$00,$00,$00,$00,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        byte $08,$08,$08,$08,$08,$08,$08,$00,$00,$00,$00,$00,$00,$00,$00,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        byte $08,$08,$08,$08,$08,$08,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        byte $08,$08,$08,$08,$08,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        byte $08,$08,$08,$08,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        byte $08,$08,$08,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        byte $08,$08,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        byte $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
'        byte $FF[32*16]
'        byte 0[32*16]
s_test_tilemap_1
'byte 255[32*16]
'

        byte $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        byte $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        byte $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        byte $FF,$FF,$FF,$FF,$06,$07,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        byte $FF,$FF,$FF,$FF,$01,$02,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        byte $FF,$FF,$FF,$FF,$01,$02,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        byte $FF,$FF,$FF,$0E,$0E,$0E,$0E,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        byte $FF,$FF,$FF,$0E,$0E,$0E,$0E,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        byte $FF,$FF,$FF,$0E,$0E,$0E,$0E,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        byte $FF,$FF,$FF,$0E,$0E,$0E,$0E,$FF,$0A,$0B,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        byte $FF,$FF,$FF,$0E,$0E,$0E,$0E,$FF,$0C,$0D,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        byte $FF,$FF,$FF,$0E,$0E,$0E,$0E,$FF,$0C,$0D,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        byte $FF,$FF,$FF,$0E,$0E,$0E,$0E,$FF,$0C,$0D,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        byte $FF,$FF,$FF,$0E,$0E,$0E,$0E,$FF,$0C,$0D,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        byte $FF,$FF,$FF,$0E,$0E,$0E,$0E,$FF,$0C,$0D,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
                               
